# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#no jars in this native build, so skip copying
%define _jarsign_opts --nocopy

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with javadoc
%bcond_without repolib
%bcond_with zip

%define eap_version_major 5
%define eap_version_minor 1
%define eap_version_revision 2


%define ep5nativedir %{_localstatedir}/lib/native
%define repodir %{_javadir}/repository.jboss.com/org/hornetq/natives/%{namedversion}-brew/RHEL-6/
%ifarch x86_64
%define repodirlib %{repodir}/x86_64
%else
%define repodirlib %{repodir}/i386
%endif
%define repodirsrc %{repodir}/src

%define reltag .CR1
%define namedversion %{version}%{reltag}

Name:		hornetq-native
Summary: 	Open source project to build a multi-protocol, embeddable, very high performance, clustered, asynchronous messaging system
Version: 	2.2.8
Release: 	1%{reltag}.1%{?dist}
Epoch:		0
License: 	ASL 2.0
Group: 		Development/Java
URL:		http://jboss.org/hornetq/
# svn export https://svn.jboss.org/repos/hornetq/tags/HornetQ_2_2_8_EAP_CR1/ hornetq-2.2.8
# Exported revision 11219.
# tar czf hornetq-2.2.8.CR1-src.tar.gz hornetq-2.2.8
Source0:        hornetq-%{namedversion}-src.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:	%{name}-component-info.xml
# https://repository.jboss.org/nexus/service/local/artifact/maven/redirect?r=central&g=org.twitter4j&a=twitter4j&v=2.1.8&e=pom
Source3:        twitter4j-core.tgz
Patch0:         %{name}-no-resteasy.patch
Patch1:         %{name}-maven-offline.patch

BuildRequires:	libaio
BuildRequires:	libaio-devel
BuildRequires:	autoconf
BuildRequires:	libtool

BuildRequires:	java-devel
BuildRequires:	ant >= 0:1.7.1
BuildRequires:	ant-nodeps >= 0:1.7.1
BuildRequires:	ant-contrib >= 0:1.0-0.b3
BuildRequires:  aopalliance
BuildRequires:	classworlds >= 0:1.1
BuildRequires:	ivy
BuildRequires:	javacc >= 0:4.0
BuildRequires:	jakarta-commons-logging >= 0:1.1.0.jboss
BuildRequires:  jakarta-commons-pool
BuildRequires:	jboss-jms-1.1-api
BuildRequires:	jboss-ejb-3.0-api
BuildRequires:  jboss-ejb3-build >= 0:1.0.0
BuildRequires:	jboss-transaction-1.0.1-api
BuildRequires:	jboss-jaspi-1.0-api
BuildRequires:	jboss-parent
BuildRequires:	jbossts >= 0:4.6.1
BuildRequires:	jboss-security-spi >= 0:2.0.3
BuildRequires:	jbosssx2 >= 0:2.0.3
BuildRequires:	jboss-microcontainer2 >= 0:2.0.6
BuildRequires:	jboss-common-core >= 0:2.2.14
BuildRequires:	jboss-integration >= 0:5.1.0
BuildRequires:	jbossws
BuildRequires:	netty >= 0:3.2.0
%if %with javadoc
BuildRequires:	apiviz >= 0:2.3.0
%endif
BuildRequires:	jboss-common-logging-spi >= 0:2.1.0
BuildRequires:	jboss-ejb3-ext-api >= 0:1.0.0
BuildRequires:	jboss-naming >= 0:5.0.3
BuildRequires:	junit >= 0:3.8.2
BuildRequires:	log4j >= 0:1.2.14
BuildRequires:  spring2-beans
BuildRequires:  spring2-core
BuildRequires:  spring2-context
BuildRequires:  spring2-jms
BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3.04
BuildRequires:  xml-commons-resolver12 >= 0:1.3.04
BuildRequires:	xerces-j2 >= 0:2.9.1

BuildRequires:  maven2 >= 0:2.0.7-8
BuildRequires:	maven-buildmagic-thirdparty-plugin
BuildRequires:	maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:	maven2-plugin-install
BuildRequires:	maven2-plugin-jar
BuildRequires:  maven2-plugin-resources
BuildRequires:	maven2-plugin-source
%if %with zip
BuildRequires: zip
%endif

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
HornetQ is an open source project to build a multi-protocol, embeddable, very
high performance, clustered, asynchronous messaging system. HornetQ is the 
new ultra high performance enterprise grade messaging system from JBoss, 
sets a record breaking score in the SPECjms2007 industry standard benchmark 
for JMS messaging system performance.
HornetQ provides message persistence using its own built-in, high 
performance journal. HornetQ has no dependency on clunky, slow, relational
databases for persistence. The journal is a unique piece of technology 
that automatically detects if running on Linux and uses Linux Asynchronous 
IO (AIO) via a native code layer for astonishing performance. If AIO is not
available seamlessly falls back to using Java NIO, so will run seamlessly 
on any Java platform.


%if %with javadoc
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%if %with zip
%package zip
Summary:        Container for the zipped distribution of %{name}.
Group:          Development

%description zip
Container for the zipped distribution of %{name}.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n hornetq-%{version}
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%{_bindir}/find -type f -name "*jar" -name "*so" | %{_bindir}/xargs -t %{__rm} -fr
#for i in `%{_bindir}/find . -name pom.xml`; do sed -i -e "s:<version>2.2.0.CR1</version>:<version>2.2.1.GA</version>:" $i; done

%build
export LANG=en_US.UTF-8
export JAVA_HOME=/usr/lib/jvm/java
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
export MAVEN_REPO_BREW=$(pwd)/maven2-brew
mkdir -p $MAVEN_REPO_LOCAL

# XXX: (dwalluck): this is part of maven-offline.patch
%{__perl} -pi -e 's|\@MAVEN_SETTINGS\@|'${M2SETTINGS}'|;' \
              -e 's|\@MAVEN_REPO_LOCAL\@|'${MAVEN_REPO_LOCAL}'|;' \
              -e 's|\@JPP_DEPMAP_FILE\@|%{SOURCE1}|;' \
              -e 's|\@MAVEN_REPO_BREW\@|'${MAVEN_REPO_BREW}'|;' \
    build-maven.xml build-thirdparty.xml  

# Add any artifacts we cannot download to local repository
pushd $MAVEN_REPO_LOCAL
# We need a package for twitter4j-core
tar xzf %{SOURCE3}
popd

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        buildmagic-thirdparty:build-thirdparty

# XXX: (dwalluck): This works around maven-buildmagic-thirdparty-plugin issue on maven 2.0.8
[ -d thirdparty ] || mv target thirdparty

ant -Dhornetq.run_script=true -Dnodownload=true -Dmaven.opts="-e -s ${M2SETTINGS} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven2.jpp.depmap.file=%{SOURCE1}"

%if %with javadoc
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc
%endif

pushd native
#./bootstrap
autoreconf --install
%configure
make clean
make
popd

%if %with zip
%ifarch x86_64
libdir=lib64
%else
libdir=lib
%endif
mkdir -p jboss-ep-%{eap_version_major}.%{eap_version_minor}/native/$libdir/
cp -pr native/src/.libs/libHornetQAIO.so* jboss-ep-%{eap_version_major}.%{eap_version_minor}/native/$libdir/
cp -pr native/src/libHornetQAIO.la jboss-ep-%{eap_version_major}.%{eap_version_minor}/native/$libdir/
zip -q -r -y jboss-ep-hornetq-native-%{eap_version_major}.%{eap_version_minor}.%{eap_version_revision}-RHEL6-%{_arch}.zip jboss-ep-%{eap_version_major}.%{eap_version_minor}
%endif

%install
%{__rm} -rf %{buildroot}
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}

%ifarch x86_64
libdir=lib64
%else
libdir=lib
%endif

install -d -m 755 $RPM_BUILD_ROOT/%{ep5nativedir}/$libdir
cp licenses/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/
cp -P native/src/.libs/libHornetQAIO.so* $RPM_BUILD_ROOT%{_libdir}/
cp -p native/src/libHornetQAIO.la $RPM_BUILD_ROOT%{_libdir}/
cp -pL $RPM_BUILD_ROOT%{_libdir}/libHornet* $RPM_BUILD_ROOT/%{ep5nativedir}/$libdir/

# repolib
%if %with repolib
	tag=`echo %{version}-brew`
	sed -i "s/@VERSION@/$tag/g" %{SOURCE2}
	tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
	sed -i "s/@TAG@/$tag/g" %{SOURCE2}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
        cp -p $RPM_BUILD_ROOT%{_libdir}/*.{la,so.0.0.0} $RPM_BUILD_ROOT%{repodirlib}
%endif

%if %with zip
install -dm 755 $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/
install -m 644 *.zip $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev
%endif

%clean
rm -Rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_libdir}/libHornetQ*
%{ep5nativedir}/lib*/*

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%if %with zip
%files zip
%defattr(-,root,root,-)
%dir %{_javadir}/jbossas-fordev
%{_javadir}/jbossas-fordev/*.zip
%endif

%changelog
* Mon Sep 12 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2.8-1.CR1.1
- Upgrade to 2.2.8.CR1

* Tue Apr 12 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2.2-2.GA.2
- Fix location of library so that it is multilib-clean

* Mon Mar 28 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2.2-1.GA.1
- 2.2.2.GA

* Wed Mar 16 2011 Permaine Cheung <pcheung@redhat.com> 0:2.2.1-1.GA.3
- 2.2.1.GA

* Wed Mar 09 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.2.0-2.GA.2
- Rebuild on RHEL 6 with 2.2.0.GA
- Remove patch already incorporated in source

* Tue Feb 01 2011 David Walluck <dwalluck@redhat.com> 0:2.2.0-0.1.CR1.2
- add patch to keep maven from going online for jar-rest
- add workaround for thirdparty build on maven 2.0.8
- update jpp-depmap.xml to allow building on JPackage 6
- BuildRequires: jboss-ejb3-build >= 0:1.0.0
- remove build root before install
- set LANG in case of unmappable characters

* Mon Jan 24 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.1.2-1.Final.0.2
- Add zip subpackage

* Mon Dec 13 2010 Fernando Nasser <fnasser@redhat.com> - 0:2.1.2-1.Final.0.1.2
- Add patch to build on i386

* Wed Aug 18 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.2-1.Final.0.1.1
- Upgrade to 2.1.2.Final

* Wed Jun 16 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.1-1.Final.0.1
- Upgrade to 2.1.1.Final

* Fri Jun 04 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.0-2.Final
- Build from 2.1.0.Final tag

* Mon May 31 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.1.0-1.CR1
- Build from 2.1.0.CR1 tag

* Mon May 17 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.0-1.3.CR3
- Update to the latest trunk for a RHEL 4 bug fix

* Wed May 12 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.0-1.2.CR3
- Fix cp command

* Wed May 12 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.0-1.1.CR3
- Create symlinks for library

* Mon May 10 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.0.0-1.CR3
- First release
